---
title: Cache.add()
slug: Web/API/Cache/add
tags:
  - API
  - Cache
  - Experimental
  - Method
  - Reference
  - Service Workers
  - Service worker API
  - ServiceWorker
---
<p>{{APIRef("Service Workers API")}}</p>

<p><span class="seoSummary">The <strong><code>add()</code></strong> method of the {{domxref("Cache")}} interface takes a URL, retrieves it, and adds the resulting response object to the given cache. </span>The <code>add()</code> method is functionally equivalent to the following:</p>

<pre class="brush: js notranslate">fetch(url).then(function(response) {
  if (!response.ok) {
    throw new TypeError('bad response status');
  }
  return cache.put(url, response);
})</pre>

<p>For more complex operations, you'll need to use {{domxref("Cache.put","Cache.put()")}} directly.</p>

<div class="note">
<p><strong>Note</strong>: <code>add()</code> will overwrite any key/value pair previously stored in the cache that matches the request.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="sytaxbox notranslate"><em>cache</em>.add(<em>request</em>).then(function() {
  // request has been added to the cache
});
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>request</dt>
 <dd>The request you want to add to the cache. This can be a  {{domxref("Request")}} object or a URL.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} that resolves with <code>undefined</code>.</p>

<h3 id="Exceptions">Exceptions</h3>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col"><strong>Exception</strong></th>
   <th scope="col"><strong>Happens when</strong></th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>TypeError</code></td>
   <td>
    <p>The URL scheme is not <code>http</code> or <code>https</code>.</p>

    <p>The Response status is not in the 200 range (i.e., not a successful response.) This occurs if the request does not return successfully, but also if the request is a <em>cross-origin no-cors</em> request (in which case the reported status is always 0.)</p>
   </td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<p>This code block waits for an {{domxref("InstallEvent")}} to fire, then calls {{domxref("ExtendableEvent.waitUntil","waitUntil()")}} to handle the install process for the app. This consists of calling {{domxref("CacheStorage.open")}} to create a new cache, then using {{domxref("Cache.add")}} to add an asset to it.</p>

<pre class="brush: js notranslate">this.addEventListener('install', function(event) {
  event.waitUntil(
    caches.open('v1').then(function(cache) {
      return cache.add('/sw-test/index.html');
    })
  );
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#cache-add', 'Cache: add')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.Cache.add")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Service_Worker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li>{{domxref("Cache")}}</li>
 <li>{{domxref("WorkerGlobalScope.caches")}}</li>
</ul>
